function Est32200_ProdutosSemMovimentacao_Service(Est32200_ProdutosSemMovimentacao_Repository, General) {
	var idutilalmox;
	var idutillcestq;
	var Dtprocessa;

	this.setParamFilial = function(cdfilial) {
		return Est32200_ProdutosSemMovimentacao_Repository.getParamFilial(cdfilial).then(function(banco) {
			var paramFilial = banco.dataset.paramfilial_paramvalidacoes[0];
			idutilalmox = paramFilial.IDUTILALMOX;
			idutillcestq = paramFilial.IDUTILLCESTQ;
			Dtprocessa = paramFilial.DTPROCESSA;
		});
	};

	this.utilizaAlmox = function() {
		if(idutilalmox === 'S'){
			return true;
		} else {
			return false;
		}
	};

	this.utilizaLocal = function() {
		if(idutillcestq === 'S') {
			return true;
		} else {
			return false;
		}
	};

	this.getDtlimite = function(dtmilite){
		var data = moment(Dtprocessa, 'DD/MM/YYYY').subtract(dtmilite, 'days').format('DD/MM/YYYY');
		return data;
	};
    
    this.getFilter = function(widget, fields, prodFin) {
        let row = widget.appliedFilter.FILTER_ROW;
        let filter = [];
        fields.forEach((f) => {
            filter.push(
            {
                "name": f,
                "operator": "=",
                "value": (f !== 'CDPRODFIN')? (f == 'NRARVOREPROD')? getNrarvoreprod(row) : row[f] : getProdFinFormatado(row.CDPRODFIN)
            });
        });
        return filter;
	};
	
	function getNrarvoreprod(row) {
		if (row.NRARVOREPRODFILTER) {
			return row.NRARVOREPRODFILTER;
		} else {
			return "T";
		}
	}
    
    function getProdFinFormatado(prodfin) {
        var masksize = getLocalVar('CDPICTPROD').replace(/[\.\-]/g, '').length - prodfin.length;
        return General.fill(prodfin, masksize, true, 'z');
    }

	this.gerarRelatorio = function(row){
		var newRow = {
			"REPORT_NAME" : 'EST32200',
			"NRORG" : row.NRORG,
			"CDFILIAL" : row.CDFILIAL,
			"CDALMOXARIFE" : row.CDALMOXARIFE,
			"CDLOCALESTOQ" : row.CDLOCALESTOQ,
			"CDPRODINI" : row.CDPRODINI,
			"CDPRODFIN" : row.CDPRODFIN,
			"DTLIMITE" : row.DTLIMITE,
			"IDTIPOMOVI" : row.IDTIPOMOVI,
			"ORDENACAO" : row.ORDENACAO,
			"NRDIAS" : row.NRDIAS,
			"NRTPARVPROD" : row.NRTPARVPROD,
			"NRARVOREPROD" : row.NRARVOREPRODFILTER,
			"DTPROCESSA" : moment(Dtprocessa, 'DD/MM/YYYY').format('DD/MM/YYYY')
		};
		return newRow;
		//return Est32200_ProdutosSemMovimentacao_Repository.gerarRelatorio(newRow);
	};
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Est32200_ProdutosSemMovimentacao_Service', Est32200_ProdutosSemMovimentacao_Service);
});