package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class TransferenciaDeEstoquePage extends PageBase {


    ///Evento de Loading da pagina
    By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:

    By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");

    //Filtro Inicial
    By clearFilter = By.xpath("//*[@data-zh-id='1246388498426628331083_filter_action_clear']");
    By IconeUnidade = By.xpath("//div[@id='NMFILIAL']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");

    //Unidade
    By SelecioanarUnidadeTransferenciaDeEstoque = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA INGREDIENTES BRASIL']");
    By IconeData = By.xpath("//*[@id='DTMOVIESTQ']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");

    //Data
    By DataEscolhidaInicial = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
    By BtnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");

    //Almoxarifado
    By AlmoxarifadoOrigem = By.xpath("//*[@data-zh-id='124638849817494643131129']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By AlmoxarifadoOrigemUnidade = By.xpath("//span[text()='HELA MATRIZ']");
    By AlmoxarifadoDestino = By.xpath("//*[@data-zh-id='1246388498209328871139']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By AlmoxarifadoDestinoUnidade = By.xpath("//span[text()='HELA LOJA']");

    //Aplicar
    By aplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro']");

    //Adicionar itens
    By BtnAdicionar = By.xpath("//*[@data-zh-id='124638849835832787421155']");


    //Tela de Transferência de Estoque
    By Salvar = By.xpath("//span[text() = 'Salvar']");

    //Produtos
    By BtnAdicionar2 = By.xpath("//*[@data-zh-id='12463884989204280871103']");

    By IconeNome = By.xpath("//div[@id='NMPRODUTO']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By Produto = By.xpath("//span[text()='Hela Poultry Broth Paste Clear KG']");

    //Lote
    By selectLote = By.xpath("//*[@data-zh-id='7645275172186633453300']//*[@tabindex='0']");
    By loteExistente = By.xpath("//ul[@class='list zh-new-select-list']/li[1]");
    By IconeLote = By.xpath("//div[@id='NRLOTEESTQ']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");

    By Lote = By.xpath("//span[text()='EST-231100']");

    //Confirmar
    By Confirmar = By.xpath("//span[text()='Confirmar']");

    //Quantidade
    By Quantidade = By. id("QTTOTLANCTO");

    //Adicionar
    By Adicionar = By.xpath("//span[text()='Adicionar']");

    //Salvar
    By Salvar2 = By.xpath("//*[@data-zh-id='12463884981816228916106']");


    //Editar Transferencia de Estoque

    By AlmoxarifadoEditado = By.xpath("//span[text()='HELA MATRIZ']");
    By Editar = By.xpath("//*[@data-zh-id='124638849835161962861157']");
    By AbaProdutos = By.linkText("Produtos");
    By BtnAdicionar3 = By.xpath("//*[@data-zh-id='12463884989204280871103']");
    By ProdutoEditado = By.xpath("//span[text()='Geflugelbruhe Paste (Hela 7562510050001)']");
    By LoteEditado = By.xpath("//span[text()='EST-231100']");


    //Excluir
    By BtnAlmoxarifadoExcluir = By.xpath("//span[text()='HELA MATRIZ']");
    By Excluir = By.xpath("//*[@data-zh-id='124638849827065391441159']");
    By BtnConfirmar = By.xpath("//span[text()='Sim']");

    public void limparFiltro(){
        click(clearFilter);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarIconeUnidade(){
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);
    }
    public void campoBusca(){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
    }
    public void  campoUnidade(String desUnidade){
        sendKeys(campoProcurarFloatControl, desUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarTransferenciaDeEstoque(){
        waitForVisibilityOfElementLocated(SelecioanarUnidadeTransferenciaDeEstoque);
        click(SelecioanarUnidadeTransferenciaDeEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarCampoData(){

        waitForVisibilityOfElementLocated(IconeData);
        click(IconeData);
    }
    public void selecionarDataInicial(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(DataEscolhidaInicial);
        click(DataEscolhidaInicial);
    }
    public void clicarBotaoFiltroOK(){
        waitForVisibilityOfElementLocated(BtnOkFiltro);
        click(BtnOkFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarAlmoxarifadoOrigem(){
        waitForVisibilityOfElementLocated(AlmoxarifadoOrigem);
        click(AlmoxarifadoOrigem);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoAlmoxarifadoOrigem(String almoxarifadoOrigem){
        sendKeys(campoProcurarFloatControl, almoxarifadoOrigem);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarAlmoxarifadoOrigem(){
        click(AlmoxarifadoOrigemUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarAlmoxarifadoDestino(){
        waitForVisibilityOfElementLocated(AlmoxarifadoDestino);
        click(AlmoxarifadoDestino);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoAlmoxarifadoDestino(String almoxarifadoDestino){
        sendKeys(campoProcurarFloatControl, almoxarifadoDestino);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarAlmoxarifadoDestino(){
        click(AlmoxarifadoDestinoUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void aplicarFilro(){
        waitForVisibilityOfElementLocated(aplicarFiltro);
        click(aplicarFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void clicarBotaoAdicionar(){
        waitForVisibilityOfElementLocated(BtnAdicionar);
        click(BtnAdicionar);
    }
    public void aguardarBotaoVisualizarExibir(){
        waitForInvisibilityOfElementLocated(BtnAdicionar);
        waitForInvisibilityOfElementLocated(loadingWait);

    }
    public void clicarSalvar(){
        waitForVisibilityOfElementLocated(Salvar);
        click(Salvar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void adicionarProduto(){
        waitForVisibilityOfElementLocated(BtnAdicionar2);
        click(BtnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarCampoNome(){
        waitForVisibilityOfElementLocated(IconeNome);
        click(IconeNome);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoProduto(String campoProduto){
        sendKeys(campoProcurarFloatControl, campoProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void selecionarProduto(){
        waitForVisibilityOfElementLocated(Produto);
        click(Produto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarLote(){
        waitForVisibilityOfElementLocated(selectLote);
        click(selectLote);
    }

    public void selecionarLoteExistente(){
        waitForVisibilityOfElementLocated(loteExistente);
        click(loteExistente);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarIconeLote(){
        waitForVisibilityOfElementLocated(IconeLote);
        click(IconeLote);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
     public void selecionarCampoLote(String campoLote){
         sendKeys(campoProcurarFloatControl, campoLote);
         waitForInvisibilityOfElementLocated(loadingWait);
         click(Lote);
         click(Lote);
         waitForInvisibilityOfElementLocated(loadingWait);
     }
    public void clicarEmConfirmar(){
        waitForVisibilityOfElementLocated(Confirmar);
        click(Confirmar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void  selecionarQuantidade(String campoQuantidade){
        waitForVisibilityOfElementLocated(Quantidade);
        sendKeys(Quantidade, campoQuantidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarEmAdicionar(){
        waitForVisibilityOfElementLocated(Adicionar);
        click(Adicionar);
        click(Adicionar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void clicarEmSalvar(){
        waitForVisibilityOfElementLocated(Salvar2);
        click(Salvar2);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //Edicao
    public void localizarALmoxarifadoEditado(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(AlmoxarifadoEditado);
    }
    public void selecionarAlmoxarifadoEditado(){
        click(AlmoxarifadoEditado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarEditar(){
        waitForVisibilityOfElementLocated(Editar);
        click(Editar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //aba produtos
    public void clicarAbaProduto(){
        waitForVisibilityOfElementLocated(AbaProdutos);
        click(AbaProdutos);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void botaoAdicionarEdicao(){
        waitForVisibilityOfElementLocated(BtnAdicionar3);
        click(BtnAdicionar3);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void selecionarProdutoEdicao(String campoProdutoEditado){
        sendKeys(campoProcurarFloatControl, campoProdutoEditado);
        waitForVisibilityOfElementLocated(ProdutoEditado);
    }
    public void selecionarSegundoProduto(){
        click(ProdutoEditado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
//Excluir

    public void clicarBotaoAlmoxarifadoExcluir(){
        waitForVisibilityOfElementLocated(BtnAlmoxarifadoExcluir);
        click(BtnAlmoxarifadoExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void botaoExcluir(){
        waitForVisibilityOfElementLocated(Excluir);
        click(Excluir);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarEmSim(){
        waitForVisibilityOfElementLocated(BtnConfirmar);
        click(BtnConfirmar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

}
